Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10552)
@@ -247,9 +247,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="Views\DataPreprocessingView.resx">
-      <DependentUpon>DataPreprocessingView.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs	(revision 10552)
@@ -21,6 +21,89 @@
 
 
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Analysis;
+
 namespace HeuristicLab.DataPreprocessing {
   public class HistogramLogic : IHistogramLogic {
+        private IPreprocessingData preprocessingData;
+    private DataTable dataTable;
+
+    public HistogramLogic(IPreprocessingData preprocessingData) {
+      this.preprocessingData = preprocessingData;
+      dataTable = new DataTable("Histogram");
+      FillDataTable();
+      preprocessingData.Changed += PreprocessingData_Changed;
+    }
+
+    private void FillDataTable() {
+      IEnumerable<string> variableNames = preprocessingData.VariableNames;
+
+      foreach (string variableName in variableNames) {
+        IList<double> values = preprocessingData.GetValues<double>(variableName);
+        DataRow row = new DataRow(variableName, "", values);
+        row.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Histogram;
+        dataTable.Rows.Add(row);
+      }
+
+    }
+
+    public IEnumerable<object> GetVariableNames() {
+      List<string> doubleVariableNames = new List<string>();
+
+      //only return variable names from type double
+      foreach (string variableName in preprocessingData.VariableNames) {
+        if (preprocessingData.IsType<double>(preprocessingData.GetColumnIndex(variableName)))
+          doubleVariableNames.Add(variableName);
+      }
+
+      return doubleVariableNames;
+    }
+
+    public DataTable GetDataTable() {
+      return dataTable;
+    }
+
+    public void RemoveVariable(string name) {
+      dataTable.Rows.Remove(name);
+    }
+
+    public void AddVariable(string name) {
+      IList<double> values = preprocessingData.GetValues<double>(name);
+      DataRow row = new DataRow(name, "", values);
+      row.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Histogram;
+      dataTable.Rows.Add(row);
+    }
+
+    public bool VariableIsDisplayed(string name) {
+
+      foreach (var item in dataTable.Rows) {
+        if (item.Name == name)
+          return true;
+      }
+      return false;
+    }
+
+    void PreprocessingData_Changed(object sender, DataPreprocessingChangedEventArgs e) {
+      var variableName = preprocessingData.GetVariableName(e.Column);
+      switch (e.Type) {
+        case DataPreprocessingChangedEventType.DeleteColumn:
+          dataTable.Rows.Remove(variableName);
+          break;
+        case DataPreprocessingChangedEventType.AddColumn:
+          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          break;
+        case DataPreprocessingChangedEventType.ChangeColumn:
+        case DataPreprocessingChangedEventType.ChangeItem:
+          dataTable.Rows.Remove(variableName);
+          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          break;
+        case DataPreprocessingChangedEventType.DeleteRow:
+        case DataPreprocessingChangedEventType.AddRow:
+          dataTable.Rows.Clear();
+          FillDataTable();
+          break;
+      }
+    }
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10552)
@@ -48,5 +48,13 @@
 
     public IEnumerable<object> GetVariableNames() {
-      return preprocessingData.VariableNames;
+      List<string> doubleVariableNames = new List<string>();
+
+      //only return variable names from type double
+      foreach (string variableName in preprocessingData.VariableNames) {
+        if (preprocessingData.IsType<double>(preprocessingData.GetColumnIndex(variableName)))
+          doubleVariableNames.Add(variableName);
+      }
+
+      return doubleVariableNames;
     }
 
@@ -54,7 +62,4 @@
       return dataTable;
     }
-
-
-    #region ILineChartLogic Members
 
     public void RemoveVariable(string name) {
@@ -67,6 +72,4 @@
       dataTable.Rows.Add(row);
     }
-
-    #endregion
 
     public bool VariableIsDisplayed(string name) {
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IHistogramLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IHistogramLogic.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IHistogramLogic.cs	(revision 10552)
@@ -21,6 +21,18 @@
 
 
+using System.Collections.Generic;
+using HeuristicLab.Analysis;
+
 namespace HeuristicLab.DataPreprocessing {
   public interface IHistogramLogic {
+    void RemoveVariable(string name);
+
+    void AddVariable(string name);
+
+    IEnumerable<object> GetVariableNames();
+
+    DataTable GetDataTable();
+
+    bool VariableIsDisplayed(string name);
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/DataPreprocessingView.cs	(revision 10552)
@@ -73,5 +73,5 @@
       tranformationContent = new TransformationContent(new TransformationLogic(data, searchLogic, statisticsLogic));
       lineChartContent = new LineChartContent(new LineChartLogic(data));
-      histogramContent = new HistogramContent(new HistogramLogic());
+      histogramContent = new HistogramContent(new HistogramLogic(data));
 
       //create view items
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.Designer.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.Designer.cs	(revision 10552)
@@ -24,9 +24,81 @@
     /// </summary>
     private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
+      this.groupBoxAttributs = new System.Windows.Forms.GroupBox();
+      this.variablesListBox = new System.Windows.Forms.CheckedListBox();
+      this.groupBoxOptions = new System.Windows.Forms.GroupBox();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.groupBoxAttributs.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // groupBoxAttributs
+      // 
+      this.groupBoxAttributs.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left)));
+      this.groupBoxAttributs.Controls.Add(this.variablesListBox);
+      this.groupBoxAttributs.Location = new System.Drawing.Point(3, 4);
+      this.groupBoxAttributs.Name = "groupBoxAttributs";
+      this.groupBoxAttributs.Size = new System.Drawing.Size(153, 252);
+      this.groupBoxAttributs.TabIndex = 3;
+      this.groupBoxAttributs.TabStop = false;
+      this.groupBoxAttributs.Text = "Attributes";
+      // 
+      // variablesListBox
+      // 
+      this.variablesListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.variablesListBox.FormattingEnabled = true;
+      this.variablesListBox.Location = new System.Drawing.Point(6, 19);
+      this.variablesListBox.Name = "variablesListBox";
+      this.variablesListBox.Size = new System.Drawing.Size(141, 229);
+      this.variablesListBox.TabIndex = 1;
+      this.variablesListBox.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.variablesListBox_ItemCheck);
+      // 
+      // groupBoxOptions
+      // 
+      this.groupBoxOptions.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.groupBoxOptions.Location = new System.Drawing.Point(4, 262);
+      this.groupBoxOptions.Name = "groupBoxOptions";
+      this.groupBoxOptions.Size = new System.Drawing.Size(152, 138);
+      this.groupBoxOptions.TabIndex = 4;
+      this.groupBoxOptions.TabStop = false;
+      this.groupBoxOptions.Text = "Options";
+      // 
+      // viewHost
+      // 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(163, 4);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(524, 396);
+      this.viewHost.TabIndex = 5;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
+      // 
+      // HistogramView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.viewHost);
+      this.Controls.Add(this.groupBoxOptions);
+      this.Controls.Add(this.groupBoxAttributs);
+      this.Name = "HistogramView";
+      this.Size = new System.Drawing.Size(690, 403);
+      this.groupBoxAttributs.ResumeLayout(false);
+      this.ResumeLayout(false);
+
     }
 
     #endregion
+
+    private System.Windows.Forms.GroupBox groupBoxAttributs;
+    private System.Windows.Forms.CheckedListBox variablesListBox;
+    private System.Windows.Forms.GroupBox groupBoxOptions;
+    private MainForm.WindowsForms.ViewHost viewHost;
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/HistogramView.cs	(revision 10552)
@@ -29,4 +29,30 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
+      if (Content != null) {
+        InitDataTable();
+        InitVariablesListBox();
+      }
+    }
+
+    private void InitVariablesListBox() {
+      IHistogramLogic logic = Content.HistogramLogic;
+
+      foreach (var variableName in logic.GetVariableNames()) {
+        variablesListBox.Items.Add(variableName, true);
+      }
+    }
+
+    private void InitDataTable() {
+      IHistogramLogic logic = Content.HistogramLogic;
+      viewHost.Content = logic.GetDataTable();
+    }
+
+    private void variablesListBox_ItemCheck(object sender, ItemCheckEventArgs e) {
+      string item = variablesListBox.Items[e.Index] as string;
+
+      if (e.NewValue == CheckState.Checked && !Content.HistogramLogic.VariableIsDisplayed(item))
+        Content.HistogramLogic.AddVariable(item);
+      else if (e.NewValue == CheckState.Unchecked && Content.HistogramLogic.VariableIsDisplayed(item))
+        Content.HistogramLogic.RemoveVariable(item);
     }
   }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/LineChartView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/LineChartView.Designer.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/LineChartView.Designer.cs	(revision 10552)
@@ -47,18 +47,21 @@
       this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.variablesListBox = new System.Windows.Forms.CheckedListBox();
+      this.groupBoxAttributs = new System.Windows.Forms.GroupBox();
+      this.groupBoxOptions = new System.Windows.Forms.GroupBox();
+      this.groupBoxAttributs.SuspendLayout();
       this.SuspendLayout();
       // 
       // viewHost
       // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.viewHost.Caption = "View";
       this.viewHost.Content = null;
       this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(155, 4);
+      this.viewHost.Location = new System.Drawing.Point(162, 4);
       this.viewHost.Name = "viewHost";
       this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(922, 559);
+      this.viewHost.Size = new System.Drawing.Size(489, 396);
       this.viewHost.TabIndex = 0;
       this.viewHost.ViewsLabelVisible = true;
@@ -67,12 +70,35 @@
       // variablesListBox
       // 
-      this.variablesListBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)));
+      this.variablesListBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.variablesListBox.FormattingEnabled = true;
-      this.variablesListBox.Location = new System.Drawing.Point(3, 4);
+      this.variablesListBox.Location = new System.Drawing.Point(6, 19);
       this.variablesListBox.Name = "variablesListBox";
-      this.variablesListBox.Size = new System.Drawing.Size(146, 559);
+      this.variablesListBox.Size = new System.Drawing.Size(141, 229);
       this.variablesListBox.TabIndex = 1;
       this.variablesListBox.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.variablesListBox_ItemCheck);
+      // 
+      // groupBoxAttributs
+      // 
+      this.groupBoxAttributs.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left)));
+      this.groupBoxAttributs.Controls.Add(this.variablesListBox);
+      this.groupBoxAttributs.Location = new System.Drawing.Point(3, 4);
+      this.groupBoxAttributs.Name = "groupBoxAttributs";
+      this.groupBoxAttributs.Size = new System.Drawing.Size(153, 252);
+      this.groupBoxAttributs.TabIndex = 2;
+      this.groupBoxAttributs.TabStop = false;
+      this.groupBoxAttributs.Text = "Attributes";
+      // 
+      // groupBoxOptions
+      // 
+      this.groupBoxOptions.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.groupBoxOptions.Location = new System.Drawing.Point(4, 262);
+      this.groupBoxOptions.Name = "groupBoxOptions";
+      this.groupBoxOptions.Size = new System.Drawing.Size(152, 138);
+      this.groupBoxOptions.TabIndex = 3;
+      this.groupBoxOptions.TabStop = false;
+      this.groupBoxOptions.Text = "Options";
       // 
       // LineChartView
@@ -80,8 +106,10 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.variablesListBox);
+      this.Controls.Add(this.groupBoxOptions);
+      this.Controls.Add(this.groupBoxAttributs);
       this.Controls.Add(this.viewHost);
       this.Name = "LineChartView";
-      this.Size = new System.Drawing.Size(1080, 582);
+      this.Size = new System.Drawing.Size(654, 403);
+      this.groupBoxAttributs.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -92,4 +120,6 @@
     private MainForm.WindowsForms.ViewHost viewHost;
     private System.Windows.Forms.CheckedListBox variablesListBox;
+    private System.Windows.Forms.GroupBox groupBoxAttributs;
+    private System.Windows.Forms.GroupBox groupBoxOptions;
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs	(revision 10551)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs	(revision 10552)
@@ -28,7 +28,4 @@
       InitializeComponent();
 
-      this.Controls.Remove(nameLabel);
-      this.Controls.Remove(nameTextBox);
-      this.Controls.Remove(infoLabel);
     }
 