Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10558)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/HeuristicLab.DataPreprocessing-3.3.csproj	(revision 10559)
@@ -69,5 +69,4 @@
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
   </ItemGroup>
   <ItemGroup>
@@ -79,5 +78,4 @@
     <Compile Include="Interfaces\IDataGridLogic.cs" />
     <Compile Include="Implementations\FilterContent.cs" />
-    <Compile Include="Implementations\DataPreprocessorStarter.cs" />
     <Compile Include="Implementations\FilterLogic.cs" />
     <Compile Include="Implementations\HistogramContent.cs" />
@@ -131,8 +129,4 @@
       <Private>False</Private>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
-      <Name>HeuristicLab.Core.Views-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
       <Project>{c36bd924-a541-4a00-afa8-41701378ddc5}</Project>
@@ -144,12 +138,4 @@
       <Name>HeuristicLab.Data-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
-      <Project>{ab687bbe-1bfe-476b-906d-44237135431d}</Project>
-      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
-      <Project>{3bd61258-31da-4b09-89c0-4f71fef5f05a}</Project>
-      <Name>HeuristicLab.MainForm-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
       <Project>{14ab8d24-25bc-400c-a846-4627aa945192}</Project>
@@ -160,8 +146,4 @@
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
       <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj">
-      <Project>{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}</Project>
-      <Name>HeuristicLab.Problems.DataAnalysis.Views-3.4</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataPreprocessorStarter.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataPreprocessorStarter.cs	(revision 10558)
+++ 	(revision )
@@ -1,62 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Windows.Forms;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-using HeuristicLab.Optimization;
-using HeuristicLab.Problems.DataAnalysis;
-using HeuristicLab.Problems.DataAnalysis.Views;
-using View = HeuristicLab.MainForm.WindowsForms.View;
-
-namespace HeuristicLab.DataPreprocessing {
-  public class DataPreprocessorStarter : IDataPreprocessorStarter {
-
-    public void Start(IDataAnalysisProblemData problemData, View currentView) {
-      IAlgorithm algorithm;
-      IDataAnalysisProblem problem;
-      IItem parentItem = GetMostOuterContent(currentView, out algorithm, out problem);
-      var context = new PreprocessingContext(problemData, algorithm, problem);
-      MainFormManager.MainForm.ShowContent(context);
-    }
-
-    private IItem GetMostOuterContent(Control control, out IAlgorithm algorithm, out IDataAnalysisProblem problem) {
-      algorithm = null;
-      problem = null;
-      ItemView itemView = null;
-      do {
-        control = control.Parent;
-        if (control is ItemView) {
-          itemView = (ItemView)control;
-          if (itemView.Content is IAlgorithm) {
-            algorithm = (IAlgorithm)itemView.Content;
-          }
-          if (itemView.Content is IDataAnalysisProblem) {
-            problem = (IDataAnalysisProblem)itemView.Content;
-          }
-        }
-      } while (control != null);
-
-      return itemView.Content;
-    }
-  }
-}