Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing.Views/3.3/DataGridContentView.cs	(revision 10571)
@@ -50,4 +50,18 @@
     }
 
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.Changed += Content_Changed;
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      Content.Changed -= Content_Changed;
+    }
+
+    void Content_Changed(object sender, DataPreprocessingChangedEventArgs e) {
+      dataGridView.Refresh();
+    }
 
     private void dataGridView_CellValidating(object sender, DataGridViewCellValidatingEventArgs e) {
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridContent.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridContent.cs	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridContent.cs	(revision 10571)
@@ -140,4 +140,8 @@
     public event EventHandler Reset;
 
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { dataGridLogic.Changed += value; }
+      remove { dataGridLogic.Changed -= value; }
+    }
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridLogic.cs	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/DataGridLogic.cs	(revision 10571)
@@ -120,4 +120,9 @@
       return valid;
     }
+
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { preprocessingData.Changed += value; }
+      remove { preprocessingData.Changed -= value; }
+    }
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridContent.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridContent.cs	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridContent.cs	(revision 10571)
@@ -26,4 +26,6 @@
     IDataGridLogic DataGridLogic { get; }
     IManipulationLogic PreprocessingDataManipulation { get; }
+
+    event DataPreprocessingChangedEventHandler Changed;
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridLogic.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridLogic.cs	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Interfaces/IDataGridLogic.cs	(revision 10571)
@@ -32,4 +32,6 @@
     bool SetValue(string value, int rowIndex, int columnIndex);
     bool Validate(string value, out string errorMessage, int columnIndex);
+
+    event DataPreprocessingChangedEventHandler Changed;
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 10570)
+++ /branches/DataPreprocessing/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 10571)
@@ -166,4 +166,9 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.DataPreprocessing-3.3, Version=3.3.9.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\bin\HeuristicLab.DataPreprocessing-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Encodings.BinaryVectorEncoding-3.3">
       <HintPath>..\bin\HeuristicLab.Encodings.BinaryVectorEncoding-3.3.dll</HintPath>
@@ -324,4 +329,7 @@
     <Reference Include="Microsoft.VisualStudio.QualityTools.UnitTestFramework, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
       <Private>false</Private>
+    </Reference>
+    <Reference Include="Rhino.Mocks">
+      <HintPath>..\packages\RhinoMocks.3.6.1\lib\net\Rhino.Mocks.dll</HintPath>
     </Reference>
     <Reference Include="System" />
@@ -361,4 +369,5 @@
     <Compile Include="HeuristicLab.Collections-3.3\BidirectionalLookupTest.cs" />
     <Compile Include="HeuristicLab.Collections-3.3\ObservableKeyedListTest.cs" />
+    <Compile Include="HeuristicLab.DataPreprocessing-3.3\StatisticInfoTest.cs" />
     <Compile Include="HeuristicLab.Encodings.BinaryVectorEncoding-3.3\Auxiliary.cs" />
     <Compile Include="HeuristicLab.Encodings.BinaryVectorEncoding-3.3\NPointCrossoverTest.cs" />
@@ -474,4 +483,5 @@
     </None>
     <None Include="HeuristicLab.snk" />
+    <None Include="packages.config" />
     <None Include="Test Resources\GA_SymbReg.hl">
       <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
@@ -503,4 +513,5 @@
     </Content>
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 