Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs	(revision 10580)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/HistogramLogic.cs	(revision 10581)
@@ -84,17 +84,17 @@
     }
 
+    //TODO: refactor: possible code duplication with LineChartLogic
     void PreprocessingData_Changed(object sender, DataPreprocessingChangedEventArgs e) {
-      var variableName = preprocessingData.GetVariableName(e.Column);
       switch (e.Type) {
         case DataPreprocessingChangedEventType.DeleteColumn:
-          dataTable.Rows.Remove(variableName);
+          dataTable.Rows.Remove(preprocessingData.GetVariableName(e.Column));
           break;
         case DataPreprocessingChangedEventType.AddColumn:
-          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          dataTable.Rows.Add(new DataRow(preprocessingData.GetVariableName(e.Column), String.Empty, preprocessingData.GetValues<double>(e.Column)));
           break;
         case DataPreprocessingChangedEventType.ChangeColumn:
         case DataPreprocessingChangedEventType.ChangeItem:
-          dataTable.Rows.Remove(variableName);
-          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          dataTable.Rows.Remove(preprocessingData.GetVariableName(e.Column));
+          dataTable.Rows.Add(new DataRow(preprocessingData.GetVariableName(e.Column), String.Empty, preprocessingData.GetValues<double>(e.Column)));
           break;
         case DataPreprocessingChangedEventType.DeleteRow:
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10580)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/LineChartLogic.cs	(revision 10581)
@@ -82,17 +82,17 @@
     }
 
+    //TODO: refactor: possible code duplication with HistogramLogic
     void PreprocessingData_Changed(object sender, DataPreprocessingChangedEventArgs e) {
-      var variableName = preprocessingData.GetVariableName(e.Column);
       switch (e.Type) {
         case DataPreprocessingChangedEventType.DeleteColumn:
-          dataTable.Rows.Remove(variableName);
+          dataTable.Rows.Remove(preprocessingData.GetVariableName(e.Column));
           break;
         case DataPreprocessingChangedEventType.AddColumn:
-          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          dataTable.Rows.Add(new DataRow(preprocessingData.GetVariableName(e.Column), String.Empty, preprocessingData.GetValues<double>(e.Column)));
           break;
         case DataPreprocessingChangedEventType.ChangeColumn:
         case DataPreprocessingChangedEventType.ChangeItem:
-          dataTable.Rows.Remove(variableName);
-          dataTable.Rows.Add(new DataRow(variableName, String.Empty, preprocessingData.GetValues<double>(e.Column)));
+          dataTable.Rows.Remove(preprocessingData.GetVariableName(e.Column));
+          dataTable.Rows.Add(new DataRow(preprocessingData.GetVariableName(e.Column), String.Empty, preprocessingData.GetValues<double>(e.Column)));
           break;
         case DataPreprocessingChangedEventType.DeleteRow:
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10580)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Implementations/PreprocessingData.cs	(revision 10581)
@@ -278,5 +278,5 @@
 
     public void BeginTransaction() {
-      SaveSnapshot(DataPreprocessingChangedEventType.Any, 0, 0); //TODO: fix event handling, so that the ints can be -1, -1
+      SaveSnapshot(DataPreprocessingChangedEventType.Any, -1, -1);
       transactionDepth++;
     }
@@ -287,5 +287,5 @@
         throw new InvalidOperationException("There is no open transaction that can be ended.");
       if (transactionDepth == 0)
-        OnChanged(DataPreprocessingChangedEventType.Any, 0, 0); //TODO: fix event handling, so that the ints can be -1, -1
+        OnChanged(DataPreprocessingChangedEventType.Any, -1, -1);
     }
 